

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.TypedQuery;

public class Main {
	private static long tS;

	public static void main(String[] args){
		EntityManagerFactory emf =
				Persistence.createEntityManagerFactory("/db/p2ty.odb;drop");
		EntityManager em = emf.createEntityManager();
		tS = System.currentTimeMillis();
		em.getTransaction().begin();
		for (int i=0; i<10; i++){
			Point p = new Point(1, (int)Math.sqrt(i)*1000);
			em.persist(p);
		}
		em.getTransaction().commit();
		printSpan();
		
		Query q1 = em.createQuery("select count(p) from Point p");
		System.out.println("Total Points: "+q1.getSingleResult());
		printSpan();
		
		Query q2 = em.createQuery("select avg(p.x) from Point p");
		System.out.println(""+q2.getSingleResult());
		printSpan();
		
		TypedQuery<Point> query = 
				em.createQuery("select p from Point p", Point.class);
		List<Point> rlt = query.getResultList();
		for ( Point p :rlt ){
			System.out.println(p);
		}
		printSpan();
		Query q3 = em.createQuery("delete * from Point p");
		System.out.println("Total Points: "+q3.getSingleResult());
		printSpan();
		
		em.close();
		emf.close();
	}

	private static void printSpan() {
		long tE = System.currentTimeMillis();
		System.out.printf("Cost time : %f s\n", (tE -tS)*0.001);
		tS = tE;
	}
}
